/*
    Clay Shooter is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Clay Shooter is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Clay Shooter.  If not, see <http://www.gnu.org/licenses/>.

#-----------------------------------------------------------------------------------------#

 Author: Federico Salotti
 Organization/Company: Mr_Robot_Computers_Repair
 Country: Italy Barga(LU)
 release: 1.0 (08 March 2020 14:02)
 website: http://mrrobotcomputers.hopto.org

*/


class Particles
{
public:
	Particles(int x, int y)
	{
		for(int i=0; i < rand()%((5-2)+1)+2; i++)
		{
			int _w=rand()%2+1;
			int _h=rand()%2+1;
			int y_speed=rand()%2+1;

			Piece particle(_w,_h,x+rand()%35+1,y+rand()%15+1,y_speed);
			this->_particles.push_back(particle);
		}
	}

	void move()
	{
		_clean();
		for(auto &particle : this->_particles)
			particle.move();
	}

	int getSize()
	{
		return this->_particles.size();
	}

	void draw(sf::RenderWindow &window)
	{
		for(auto &piece : this->_particles)
			piece.draw(window);
	}
private:
std::vector<Piece> _particles;

void _clean()
{
	for(auto particle=this->_particles.begin(); particle != this->_particles.end(); ++particle)
	{
		if(particle->getXY().y > 200)
		{
			this->_particles.erase(particle);
			--particle;
		}
	}
}


};
