/*
    Clay Shooter is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Clay Shooter is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Clay Shooter.  If not, see <http://www.gnu.org/licenses/>.

#-----------------------------------------------------------------------------------------#

 Author: Federico Salotti
 Organization/Company: Mr_Robot_Computers_Repair
 Country: Italy Barga(LU)
 release: 1.0 (08 March 2020 14:02)
 website: http://mrrobotcomputers.hopto.org

*/


class Piece
{
public:
	Piece(int w, int h, int x, int y, int yspeed)
	{
		this->_w=w;
		this->_h=h;
		this->_yspeed=yspeed;

		this->_piece.setSize(sf::Vector2f(this->_w,this->_h));
		this->_piece.setOutlineThickness(0.5);
		this->_piece.setOutlineColor(sf::Color::Black);
		this->_piece.setFillColor(sf::Color::White);
		this->_piece.setPosition(x,y);
	}

	sf::Vector2f getXY()
	{
		return this->_piece.getPosition();
	}

	void move()
	{
		this->_piece.move(0,this->_yspeed);
	}

	void draw(sf::RenderWindow &window)
	{
		window.draw(this->_piece);
	}

private:
sf::RectangleShape _piece;
int _w=0;
int _h=0;
int _yspeed=0;
};
