/*
    Clay Shooter is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Clay Shooter is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Clay Shooter.  If not, see <http://www.gnu.org/licenses/>.

#-----------------------------------------------------------------------------------------#

 Author: Federico Salotti
 Organization/Company: Mr_Robot_Computers_Repair
 Country: Italy Barga(LU)
 release: 1.0 (08 March 2020 14:02)
 website: http://mrrobotcomputers.hopto.org

*/


class Plate
{
public:
	Plate(sf::Texture &texture, sf::Texture &texture2)
	{
		this->_hit_texture=texture2;
		this->_plate.setTexture(texture);
	}

	sf::FloatRect getGlobalBounds()
	{
		return this->_plate.getGlobalBounds();
	}

	sf::Vector2f getDistance()
	{
		return this->_plate.getScale();
	}

	void setPosition(sf::Vector2f pos)
	{
		this->_plate.setPosition(pos.x,pos.y);
	}

	bool onRightHigh()
	{
		if(this->_plate.getPosition().x > 300 &&
			this->_plate.getPosition().y < 300) return true;
		return false;
	}

	bool onLeftHigh()
	{
		if(this->_plate.getPosition().x < 300 &&
			this->_plate.getPosition().y < 300) return true;
		return false;
	}

	bool onLeftLow()
	{
		if(this->_plate.getPosition().x < 300 &&
			this->_plate.getPosition().y >= 300) return true;
		return false;
	}

	bool onRightLow()
	{
		if(this->_plate.getPosition().x > 300 &&
			this->_plate.getPosition().y >= 300) return true;
		return false;
	}

	bool toHorizon()
	{
		if(this->_plate.getPosition().x == this->_plate.getPosition().y)
			return true;
		return false;
	}

	void setMovement(float x, float y)
	{
		this->_x_speed=x;
		this->_y_speed=y;
	}

	sf::Vector2f getXY()
	{
		return this->_plate.getPosition();
	}

	void broke()
	{
		this->_plate.setTexture(this->_hit_texture);
		this->_hit=true;
	}

	void move()
	{
		if(this->_ready && !this->_hit && this->_plate.getPosition().y > 20)
			this->_plate.move(this->_x_speed,this->_y_speed);

	}

	void step_away()
	{
		if(!this->_hit) this->_plate.setScale(this->_plate.getScale().x/2,this->_plate.getScale().y/2);
	}

	void setReady()
	{
		this->_ready=true;
	}

	bool isReady()
	{
		return this->_ready;
	}

	bool isBroke()
	{
		return this->_hit;
	}

	void draw(sf::RenderWindow &window)
	{
		window.draw(this->_plate);
	}
private:
sf::Texture _hit_texture;
sf::Texture _texture;
sf::Sprite _plate;
float _x_speed=0;
float _y_speed=0;
bool _ready=false;
bool _hit=false;

};
